/****************************************************************************
 * tx.cs.iconv
 * An implementation of tx.charset.ICharset using iconv
 ****************************************************************************/

module tx.cs.iconv;
import std.utf;
import tx.cs.interfaces;
import tx.cs.iconvh;

class Charset : ICharset
{
	this( char* cs )
	{ 
		n2u = new Iconv(cs, "UTF-8");
		u2n = new Iconv("UTF-8", cs);
	}

	private Iconv n2u, u2n;

//override:
	string toUTF8( string s )
	{
		return n2u(s);
	}

	wstring toUTF16( string s )
	{
		return .toUTF16(n2u(s));
	}

	dstring toUTF32( string s )
	{
		return .toUTF32(n2u(s));
	}

	string fromUTF8( string s )
	{
		return u2n(s);
	}

	string fromUTF16( wstring s )
	{
		return u2n(.toUTF8(s));
	}

	string fromUTF32( dstring s )
	{
		return u2n(.toUTF8(s));
	}
}
